;12 Feb 2016
ORG 0000H
LJMP MAIN

seq4steps EQU 7	   
seq4:  dw 1111110000111111b  ;mark leds on or off
       dw 1111100000011111b  
	   dw 1111000000001111b
	   dw 1110000000000111b  
	   dw 1100000000000011b  
	   dw 1000000000000001b  
       dw 0  
	   



seq2steps EQU 9
seq2:  dw 1111110000000000b  ;mark leds on or off
       dw 0111110010000000b
	   dw 0011110011000000b
	   dw 0001110011100000b
	   dw 0000110011110000b
	   dw 0000010011111000b
	   dw 0000000011111100b
	   dw 0000000001111110b
	   dw 0000000000111111b
	


seq1steps EQU 16	   
seq1:  dw 1000000000000000b  ;mark leds on or off
       dw 1100000000000000b  
	   dw 1110000000000000b
	   dw 1111000000000000b  
	   dw 1111100000000000b  
	   dw 1111110000000000b  
	   dw 1111111000000000b  
	   dw 1111111100000000b  
	   dw 1111111110000000b  
	   dw 1111111111000000b  
	   dw 1111111111100000b
	   dw 1111111111110000b  
	   dw 1111111111111000b  
	   dw 1111111111111100b
	   dw 1111111111111110b  
	   dw 1111111111111111b
	   
	
   
table_count equ 40h



MAIN:

bigloop:
   
    mov table_count,#seq2steps;
    mov dptr,#seq2  ;address pattern block
	call displayloop;
	call longdelay;    ;pause
	
    mov table_count,#seq4steps;
    mov dptr,#seq4  ;address pattern block
	call displayloop;
	call longdelay;    ;pause
	
    mov table_count,#seq1steps;
    mov dptr,#seq1  ;address pattern block
	call displayloop;
	call longdelay;    ;pause

	jmp bigloop;
	


displayloop:              
     mov A,#0
     movc A,@A+dptr ;get the top 6 bits
	 call mirrorbyte;
	 mov P0,A      ;display pattern
	 inc dptr
	 mov A,#0
     movc A,@A+dptr ;get the low 6 bits
	 call mirrorbyte;
	 mov P2,A
	 inc dptr
	 call delay2       ;pause
	 djnz table_count,displayloop	 
     ret	 




longdelay:    ;pause
     call delay2;
	 call delay2;
	 call delay2;
	 call delay2;
	 ret
	 
  
delay2:
    mov r2,#4
outloop:  
    MOV R0,#0FFH
INLOP:
    MOV R1,#0FFH	
	DJNZ R1,$
	DJNZ R0,INLOP
	DJNZ R2,outloop;
	ret
	
	
mirrorbyte: ;Reverse the bit order to suit the display hardware
            ;Bit 7 becomes bit 0
    MOV R0,#0 
    MOV R1,#8  ;8 bits
mirrorloop:	
	RLC A;  ;move top bit into carry
	XCH A,R0  ;work on new copy
	RRC A;    ;shift right, carry become top bit
    XCH A,R0;  ;back to normal
	DJNZ R1,mirrorloop;   ;next bit
	XCH A,R0              ;return new pattern in A
	ret
	

				
END 



